using Benchmark;
using NUnit.Framework;

namespace TestProject1
{
    public class Tests
    {
        [SetUp]
        public void Setup()
        {
        }

        [Test]
        public void Test03()
        {
            var actual = new TrailingNumberFromString().GetTrailingNumberFromString3();
            Assert.AreEqual(1234, actual);
        }

        [Test]
        public void Test04()
        {
            var actual = new TrailingNumberFromString().GetTrailingNumberFromString4();
            Assert.AreEqual(1234, actual);
        }

        [Test]
        public void Test05()
        {
            var actual = new TrailingNumberFromString().GetTrailingNumberFromString5();
            Assert.AreEqual(1234, actual);
        }

        [Test]
        public void Test06()
        {
            var actual = new IdentityParser().ParseWithoutRegex();
            Assert.AreEqual("ABZ", actual?.Prefix);
            Assert.AreEqual(1, actual?.Index);
            Assert.AreEqual(1, actual?.Revision);
        }

        [Test]
        public void Test07()
        {
            var actual = new IdentityParser().ParseWithRegex();
            Assert.AreEqual("ABZ", actual?.Prefix);
            Assert.AreEqual(1, actual?.Index);
            Assert.AreEqual(1, actual?.Revision);
        }

        [Test]
        public void Test08()
        {
            Assert.IsTrue(Identity.TryParse("TOPFTP0000123-12", out var actual));
            Assert.AreEqual("TOPFTP", actual.Prefix);
            Assert.AreEqual(123, actual.Index);
            Assert.AreEqual(12, actual.Revision);
        }
        
        [Test]
        public void Test09()
        {
            Assert.IsTrue(Identity.TryParse("WPR1000023-12", out var actual));
            Assert.AreEqual("WPR", actual.Prefix);
            Assert.AreEqual(1000023, actual.Index);
            Assert.AreEqual(12, actual.Revision);
        }
        
        [Test]
        public void Test10()
        {
            Assert.IsFalse(Identity.TryParse("WPR0001023+12", out _));
            Assert.IsFalse(Identity.TryParse("Peter", out _));
            Assert.IsFalse(Identity.TryParse("NCL1-1", out _));
            Assert.IsFalse(Identity.TryParse("NCL0000001-0", out _));
            Assert.IsFalse(Identity.TryParse("NCL0000000-1", out _));
            Assert.IsFalse(Identity.TryParse("Nc0000001-1", out _));
            Assert.IsFalse(Identity.TryParse("0000001-1", out _));
        }
    }
}